ABS     ;( n -- u , Returns the absolute value of n )
        cmp     cell tosreg, 0
        jge     .end
        neg     cell tosreg
.end
        ret
end ABS



NEGATE  ;( n -- -n , Arithmetic inverse )
        neg     cell tosreg
        ret
end NEGATE



PLUS   ;( n1 n2 -- n1+n2 )
        push    eax
        upop    eax
        add     tosreg, eax
        pop     eax
        ret
end PLUS


MINUS   ;( n1 n2 -- n1-n2 )
        push    eax
        upop    eax
        sub     tosreg, eax
        pop     eax
        ret
end MINUS


_1PLUS  ; 1+ ( n1 -- n2 , increment n1 )
        inc     cell tosreg
        ret
end _1PLUS


_1MINUS  ; 1- ( n1 -- n2 , decrement n1 )
        dec     cell tosreg
        ret
end _1MINUS



_2MUL   ; 2* ( n1 -- n2 )
        shl     cell tosreg, 1
        ret
end _2MUL


_2DIV   ; 2/ ( n1 -- n2 )
        sar     cell tosreg, 1
        ret
end _2DIV


MULTIPLY        ; * ( n1 n2 -- n3 )
        push    eax

        upop    eax
        imul    eax, cell tosreg
;        imul    cell tosreg
        mov     tosreg, eax

        pop     eax
        ret
end MULTIPLY



DIVIDE          ; / ( n1 n2 -- n3 , Divide n1 by n2 )
        push    eax
        push    edx

        call    SWAP
        upop    eax
        ccd
        idiv    cell tosreg
        mov     tosreg, eax

        pop     edx
        pop     eax
        ret
end DIVIDE



MOD             ; MOD ( n1 n2 -- n3 , n3=Remainder of n1 divided by n2 )
        push    eax
        push    edx

        call    SWAP
        upop    eax
        ccd
        idiv    cell tosreg
        mov     tosreg, edx

        pop     edx
        pop     eax
        ret
end MOD



DIV_MOD         ; /MOD ( n1 n2 -- remainder quotient )
        push    eax
        push    edx

        call    SWAP
        upop    eax
        ccd
        idiv    cell tosreg
        mov     tosreg, edx
        upsh    eax

        pop     edx
        pop     eax
        ret
end DIV_MOD



MUL_DIV         ; */ ( n1 n2 n3 -- n4 , n4 = n1 * n2 / n3 )
                ;No chance for overflow (double-cell intermediate value)
        push    eax
        push    ebx
        push    edx

        upop    ebx             ;n3=Divisor
        upop    eax             ;n2=Multiplicand
        imul    cell tosreg     ;edx:eax=Dividend
        idiv    ebx
        mov     tosreg, eax

        pop     edx
        pop     ebx
        pop     eax
        ret
end MUL_DIV



MUL_DIV_MOD     ; */MOD ( n1 n2 n3 -- remainder quotient )
        push    eax
        push    ebx
        push    edx

        upop    ebx             ;n3=Divisor
        upop    eax             ;n2=Multiplicand
        imul    cell tosreg     ;edx:eax=Dividend
        idiv    ebx
        mov     tosreg, edx
        upsh    eax

        pop     edx
        pop     ebx
        pop     eax
        ret
end MUL_DIV_MOD



M_MULTIPLY      ; M* ( n1 n2 -- d , Multiply w/ double-cell result )
        push    eax

        upop    eax
        imul    cell tosreg

;Note: These might be backwards. If so, switch eax & edx
        mov     tosreg, eax
        upsh    edx

        pop     eax
        ret
end M_MULTIPLY

